/* GCodeMapper - maps movements of a g-code program from one surface to another, eg. plane to cylinder.
   Copyright (C) 2013 Martin Lederhilger <martin.lederhilger@gmx.at>

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "GCodeWriter.h"
#include "PreConditionCheck.h"

#include <cassert>
#include <sstream>
#include <locale>
#include <boost/format.hpp>

namespace GCodeWriter
{
  template<class ParamT>
  std::string generateWordWithParameter(const std::string& letter, ParamT parameter)
  {
    std::stringstream sstream;
    sstream.imbue(std::locale::classic());
    sstream << parameter;
    
    return boost::str(boost::format("%1%%2%") % letter % sstream.str());
  }
  
  template std::string generateWordWithParameter<int>(const std::string&, int);
  template std::string generateWordWithParameter<double>(const std::string&, double);
}
