/* GCodeMapper - maps movements of a g-code program from one surface to another, eg. plane to cylinder.
   Copyright (C) 2013 Martin Lederhilger <martin.lederhilger@gmx.at>

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PRECONDITIONCHECK_H
#define PRECONDITIONCHECK_H

#include <stdexcept>
#include <string>

/// \brief This function is for pre condition checks.
/// \param bool If condition is false then the exception is thrown.
/// \param what This string is passed to the exception.
/// \tparam ExceptT Type of exception to throw.
template<class ExceptT>
void pcc(bool condition, const std::string& what)
{
  if(!condition)
    throw ExceptT(what);
}

#endif